$USE "SuperEdit.lib"

' EDITOR COMMENTS STYLE
CONST SE_ANSISTYLE                = 0
CONST SE_PASCALSTYLE              = 1
CONST SE_CSTYLE                   = 2
CONST SE_ASMSTYLE                 = 3
CONST SE_BASICSTYLE               = 4
CONST SE_VBSTYLE                  = 5

' EDITOR OPTIONS
CONST SEO_ALTSETSCOLUMNMODE       = 0
CONST SEO_AUTOINDENT              = 1
CONST SEO_AUTOSIZEMAXSCROLLWIDTH  = 2
CONST SEO_DISABLESCROLLARROWS     = 3
CONST SEO_DRAGDROPEDITING         = 4
CONST SEO_DROPFILES               = 5
CONST SEO_ENHANCEHOMEKEY          = 6
CONST SEO_GROUPUNDO               = 7
CONST SEO_HALFPAGESCROLL          = 8
CONST SEO_HIDESHOWSCROLLBARS      = 9
CONST SEO_KEEPCARETX              = 10
CONST SEO_NOCARET                 = 11
CONST SEO_NOSELECTION             = 12
CONST SEO_RIGHTMOUseMOVESCURSOR   = 13
CONST SEO_SCROLLBYONELESS         = 14
CONST SEO_SCROLLHINTFOLLOWS       = 15
CONST SEO_SCROLLPASTEOF           = 16
CONST SEO_SCROLLPASTEOL           = 17
CONST SEO_SHOWSCROLLHINT          = 18
CONST SEO_SHOWSPECIALCHARS        = 19
CONST SEO_SMARTTABDELETE          = 20
CONST SEO_SMARTTABS               = 21
CONST SEO_SPECIALLINEDEFAULTFG    = 22
CONST SEO_TABINDENT               = 23
CONST SEO_TABSTOSPACES            = 24
CONST SEO_TRIMTRAILINGSPACES      = 25

' EDITOR MESSAGES
SETID "SEM_ADDLINETEXT", 40000
SETID "SEM_DELLINE", 40001
SETID "SEM_INSERTLINE", 40004
SETID "SEM_INDEXOF", 40005
SETID "SEM_EXCHANGE", 40006
SETID "SEM_CLEAR", 40007
SETID "SEM_LOADFROMFILE", 40008
SETID "SEM_SAVETOFILE", 40009
SETID "SEM_PRINT", 40010
SETID "SEM_EXPORTHTML", 40011
SETID "SEM_EXPORTRTF", 40012
SETID "SEM_ADDBOOKMARKBMP", 40013
SETID "SEM_SETBOOKMARK", 40014
SETID "SEM_DELBOOKMARK", 40015
SETID "SEM_SETBOUNDS", 40016
SETID "SEM_GETBOUNDS", 40017
SETID "SEM_SETTEXT", 40018
SETID "SEM_GETTEXT", 40019
SETID "SEM_SETLINETEXT", 40020
SETID "SEM_GETLINETEXT", 40021
SETID "SEM_SETCARETXY", 40022
SETID "SEM_GETCARETXY", 40023
SETID "SEM_SETBKCOLOR", 40024
SETID "SEM_GETBKCOLOR", 40025
SETID "SEM_SETACTIVELINECOLOR", 40026
SETID "SEM_GETACTIVELINECOLOR", 40027
SETID "SEM_SETSPECIALLINEINFO", 40028
SETID "SEM_GETSPECIALLINEINFO", 40144
SETID "SEM_SETTOPLINE", 40029
SETID "SEM_GETTOPLINE", 40030
SETID "SEM_SETGUTTERWIDTH", 40031
SETID "SEM_GETGUTTERWIDTH", 40032
SETID "SEM_SETGUTTERCOLOR", 40033
SETID "SEM_GETGUTTERCOLOR", 40034
SETID "SEM_SETFONTNAME", 40035
SETID "SEM_GETFONTNAME", 40036
SETID "SEM_SETFONTSIZE", 40037
SETID "SEM_GETFONTSIZE", 40038
SETID "SEM_SETSELECTIONMODE", 40039
SETID "SEM_GETSELECTIONMODE", 40040
SETID "SEM_SETSELECTIONCOLOR", 40041
SETID "SEM_GETSELECTIONCOLOR", 40042
SETID "SEM_SETWANTTABS", 40043
SETID "SEM_GETWANTTABS", 40044
SETID "SEM_SETWANTRETURNS", 40045
SETID "SEM_GETWANTRETURNS", 40046
SETID "SEM_SETWORDWRAP", 40047
SETID "SEM_GETWORDWRAP", 40048
SETID "SEM_SETWORDWRAPBMP", 40049
SETID "SEM_GETWORDWRAPBMP", 40050
SETID "SEM_SETREADONLY", 40051
SETID "SEM_GETREADONLY", 40052
SETID "SEM_SETINSERTCARET", 40053
SETID "SEM_GETINSERTCARET", 40054
SETID "SEM_SETOVERWRITECARET", 40144
SETID "SEM_GETOVERWRITECARET", 40145
SETID "SEM_SETRIGHTEDGE", 40055
SETID "SEM_GETRIGHTEDGE", 40056
SETID "SEM_SETRIGHTEDGECOLOR", 40057
SETID "SEM_GETRIGHTEDGECOLOR", 40058
SETID "SEM_SETOPTIONS", 40059
SETID "SEM_GETOPTIONS", 40060
SETID "SEM_SETKEYWORDS", 40061
SETID "SEM_GETKEYWORDS", 40062
SETID "SEM_SETKEYSATTRIBUTES", 40063
SETID "SEM_GETKEYSATTRIBUTES", 40064
SETID "SEM_SETSTRINGATTRIBUTES", 40065
SETID "SEM_GETSTRINGATTRIBUTES", 40066
SETID "SEM_SETSYMBOLATTRIBUTES", 40067
SETID "SEM_GETSYMBOLATTRIBUTTES", 40068
SETID "SEM_SETCOMMENTATTRIBUTES", 40069
SETID "SEM_GETCOMMENTATTRIBUTES", 40070
SETID "SEM_SETDOTATTRIBUTES", 40071
SETID "SEM_GETDOTATTRIBUTES", 40072
SETID "SEM_SETNUMBERATTRIBUTES", 40073
SETID "SEM_GETNUMBERATTRIBUTES", 40074
SETID "SEM_SETID ENTIFIERATTRIBUTES", 40075
SETID "SEM_GETIDENTIFIERATTRIBUTES", 40076
SETID "SEM_SETID ENTIFIERCHAR", 40077
SETID "SEM_GETIDENTIFIERCHAR", 40078
SETID "SEM_SETDOLARVARIBLES", 40079
SETID "SEM_GETDOLARVARIBLES", 40080
SETID "SEM_SETDOTACTIVE", 40081
SETID "SEM_GETDOTACTIVE", 40082
SETID "SEM_SETDOUBLEQUOTES", 40083
SETID "SEM_GETDOUBLEQUOTES", 40084
SETID "SEM_SETERRORLINE", 40085
SETID "SEM_GETERRORLINE", 40086
SETID "SEM_SETBREAKLINE", 40087
SETID "SEM_GETBREAKLINE", 40088
SETID "SEM_GETERRORLINECOLOR", 40089
SETID "SEM_GETBREAKLINECOLOR", 40090
SETID "SEM_LOADATTRIBUTESFROMINI", 40097
SETID "SEM_SAVEATTRIBUTESTOINI", 40107
SETID "SEM_SETCOMMENTSTYLE", 40098
SETID "SEM_GETCOMMENTSTYLE", 40099
SETID "SEM_INVALIDATE", 40100
SETID "SEM_INVALIDATEGUTTER", 40101
SETID "SEM_REPAINT", 40102
SETID "SEM_UPDATE", 40103
SETID "SEM_ADDKEYWORD", 40108
SETID "SEM_DELETEKEYWORD", 40109
SETID "SEM_SETMAXUNDO", 40110
SETID "SEM_GETMAXUNDO", 40111
SETID "SEM_SETHIDESELECTION", 40112
SETID "SEM_GETHIDESELECTION", 40113
SETID "SEM_SETTABSTOP", 40114
SETID "SEM_GETTABSTOP", 40115
SETID "SEM_SETTABWIDTH", 40116
SETID "SEM_GETTABWIDTH", 40117
SETID "SEM_SETSCROLLBARS", 40118
SETID "SEM_GETSCROLLBARS", 40119
SETID "SEM_SETSCROLLHINTCOLOR", 40120
SETID "SEM_GETSCROLLHINTCOLOR", 40121
SETID "SEM_SETSCROLLHINTFORMAT", 40122
SETID "SEM_GETSCROLLHINTFORMAT", 40123
SETID "SEM_SETHINT", 40124
SETID "SEM_GETHINT", 40125
SETID "SEM_SETSHOWHINT", 40126
SETID "SEM_GETSHOWHINT", 40127
SETID "SEM_FINDSTRING", 40130
SETID "SEM_REPLACESTRING", 40131
SETID "SEM_GETPATHNAME", 40132
SETID "SEM_REDO", 40135
SETID "SEM_UNDO", 40136
SETID "SEM_PASTE", 40137
SETID "SEM_CUT", 40138
SETID "SEM_COPY", 40139
SETID "SEM_SELECTALL", 40140
SETID "SEM_CANREDO", 40141
SETID "SEM_CANUNDO", 40142
SETID "SEM_CANPASTE", 40143

' EDITOR NOTIFICATIONS
SETID "SEN_CLICK", 40091
SETID "SEN_DBLCLICK", 40092
SETID "SEN_GUTTERCLICK", 40093
SETID "SEN_CHANGE", 40094
SETID "SEN_SCROLL", 40095
SETID "SEN_MOUseCURSOR", 40096
SETID "SEN_GUTTERPAINT", 40104
SETID "SEN_PAINT", 40105
SETID "SEN_STATUSCHANGE", 40106
SETID "SEN_ENTER", 40128
SETID "SEN_EXIT", 40129

TYPE T_RECT
     UINT Left
     UINT Top 
     UINT Right
     UINT Bottom
ENDTYPE

TYPE T_PRINTINFO
     UINT Title
     UINT Header
     UINT Footer
     UINT FontFace
     UINT FontSize
ENDTYPE

TYPE T_ATTRIBUTES
     UINT Background
     UINT Foreground
     UINT Bold      
     UINT Italic    
     UINT Underline  
     UINT Strikeout  
ENDTYPE

TYPE T_SEARCHREPLACE
     UINT FindString
     UINT ReplaceString
     UINT MatchCase
     UINT WholeWord
     UINT Backwards
     UINT EntireScope
     UINT SelectedOnly
     UINT Replace
     UINT ReplaceAll
     UINT Prompt
ENDTYPE

TYPE T_SPECIALLINEINFO
     UINT ErrorLine
     UINT BreakLine
     UINT ErrorColor
     UINT BreakColor
ENDTYPE

DECLARE IMPORT, Editor_Create(Parent AS UINT, X AS UINT, Y AS UINT, Width AS UINT, Height AS UINT), UINT
DECLARE IMPORT, Editor_Free(Handle AS UINT)
DECLARE IMPORT, SetDLLHost(Handle AS UINT)
DECLARE IMPORT, FreeAll()

SUB LoWord(Value AS UINT), UINT
	IF (Value & 0x8000) = 0
		RETURN Value & 0xFFFF
	ELSE
		RETURN Value | 0xFFFF0000
	ENDIF
ENDSUB

SUB HiWord(Value AS UINT), UINT
	RETURN (Value & 0xFFFF0000) / 0x10000
ENDSUB

SUB MakeLong(Low AS WORD,High AS WORD), UINT
   RETURN (Low | High) >> 16
ENDSUB

SUB Editor_SetBounds(Handle AS UINT, X AS UINT, Y AS UINT, Width AS UINT, Height AS UINT)
	T_RECT Bounds

	Bounds.Left   = X
	Bounds.Top    = Y
	Bounds.Right  = Width
	Bounds.Bottom = Height

	SENDMESSAGE(Handle, @SEM_SETBOUNDS, 0, Bounds)
ENDSUB

SUB Editor_GetFontName(Handle AS UINT), STRING
	POINTER Buffer

	SENDMESSAGE(Handle, @SEM_GETFONTNAME, 0, Buffer)

	MESSAGEBOX(Handle, #<STRING>Buffer, "Test")

	RETURN #<STRING>Buffer
ENDSUB

SUB Editor_GetCaretX(Handle AS UINT), WORD
	RETURN LoWord(SENDMESSAGE(Handle, @SEM_GETCARETXY, 0, 0))
ENDSUB

SUB Editor_GetCaretY(Handle AS UINT), WORD
	RETURN HiWord(SENDMESSAGE(Handle, @SEM_GETCARETXY, 0, 0))
ENDSUB